﻿<%@ Page Language="VB" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    Protected Sub grid_RowUpdating(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewUpdateEventArgs)
        Dim row As GridViewRow = grid.Rows(e.RowIndex)
        Dim publish As DropDownList = DirectCast(row.FindControl("ddlPublish"), DropDownList)
        Dim price As TextBox = DirectCast(row.FindControl("txtPrice"), TextBox)
        Dim publishDate As TextBox = DirectCast(row.FindControl("txtPublishDate"), TextBox)
        e.NewValues("publish") = publish.SelectedValue
        e.NewValues("price") = price.Text
        e.NewValues("publishDate") = publishDate.Text
    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>GridViewコントロール</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:GridView ID="grid" runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False"
            CellPadding="4" DataKeyNames="isbn" DataSourceID="sds" ForeColor="#333333" GridLines="None"
            PageSize="3" OnRowUpdating="grid_RowUpdating">
            <FooterStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <Columns>
                <asp:ImageField DataAlternateTextField="title" DataAlternateTextFormatString="{0}"
                    DataImageUrlField="isbn" DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}_logo.jpg"
                    HeaderText="ロゴ">
                </asp:ImageField>
                <asp:HyperLinkField DataNavigateUrlFields="isbn" DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/"
                    DataTextField="isbn" DataTextFormatString="ISBN{0}" HeaderText="ISBNコード" SortExpression="isbn"
                    Target="_blank" />
                <asp:BoundField DataField="title" HeaderText="書名" SortExpression="title" />
                <asp:TemplateField HeaderText="出版社" SortExpression="publish">
                    <EditItemTemplate>
                        <asp:DropDownList ID="ddlPublish" runat="server" DataSourceID="sdsPub" DataTextField="name"
                            DataValueField="name" SelectedValue='<%# Bind("publish") %>'>
                        </asp:DropDownList><asp:SqlDataSource ID="sdsPub" runat="server" CacheDuration="6000"
                            ConnectionString="<%$ ConnectionStrings:myDb %>" EnableCaching="True" SelectCommand="SELECT [name] FROM [publish]">
                        </asp:SqlDataSource>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%# Bind("publish") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="単価" SortExpression="price">
                    <EditItemTemplate>
                        <asp:TextBox ID="txtPrice" runat="server" Columns="5" Text='<%# Bind("price") %>'></asp:TextBox>円<asp:RequiredFieldValidator
                            ID="reqPrice" runat="server" ControlToValidate="txtPrice" Display="Dynamic" ErrorMessage="価格は必須です。"
                            SetFocusOnError="True" ValidationGroup="grid">*</asp:RequiredFieldValidator><asp:RangeValidator
                                ID="rngPrice" runat="server" ControlToValidate="txtPrice" Display="Dynamic" ErrorMessage="価格は0～100000円の間で入力してください。"
                                MaximumValue="100000" MinimumValue="0" SetFocusOnError="True" ValidationGroup="grid" Type="Integer">*</asp:RangeValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" Text='<%# Bind("price", "{0:#,###}円") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="刊行日" SortExpression="publishDate">
                    <EditItemTemplate>
                        <asp:TextBox ID="txtPublishDate" runat="server" Columns="12" Text='<%# Bind("publishDate","{0:yyyy/MM/dd}") %>'></asp:TextBox><asp:CompareValidator ID="cmpPublishDate" runat="server" ControlToValidate="txtPublishDate"
                            Display="Dynamic" ErrorMessage="刊行日はYYYY/MM/DD形式で入力してください。" Operator="DataTypeCheck"
                            SetFocusOnError="True" ValidationGroup="grid" Type="Date">*</asp:CompareValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label3" runat="server" Text='<%# Bind("publishDate", "{0:yyyy年MM月dd日}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField ShowHeader="False">
                    <EditItemTemplate>
                        <asp:Button ID="Button1" runat="server" CausesValidation="True" CommandName="Update"
                            Text="更新" ValidationGroup="grid" />&nbsp;<asp:Button ID="Button2" runat="server"
                                CausesValidation="False" CommandName="Cancel" Text="キャンセル" />
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Button ID="Button1" runat="server" CausesValidation="False" CommandName="Edit"
                            Text="編集" />&nbsp;<asp:Button ID="Button2" runat="server" CausesValidation="False"
                                CommandName="Delete" OnClientClick="return confirm('本当に削除しても良いですか？')" Text="削除" />
                    </ItemTemplate>
                </asp:TemplateField>
            </Columns>
            <RowStyle BackColor="#E3EAEB" />
            <EditRowStyle BackColor="#7C6F57" />
            <SelectedRowStyle BackColor="#C5BBAF" Font-Bold="True" ForeColor="#333333" />
            <PagerStyle BackColor="#666666" ForeColor="White" HorizontalAlign="Center" />
            <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <AlternatingRowStyle BackColor="White" />
        </asp:GridView>
        <asp:SqlDataSource ID="sds" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>"
            DeleteCommand="DELETE FROM [books] WHERE [isbn] = @original_isbn AND [title] = @original_title AND [publish] = @original_publish AND [price] = @original_price AND [publishDate] = @original_publishDate"
            InsertCommand="INSERT INTO [books] ([isbn], [title], [publish], [price], [publishDate]) VALUES (@isbn, @title, @publish, @price, @publishDate)"
            OldValuesParameterFormatString="original_{0}" SelectCommand="SELECT [isbn], [title], [publish], [price], [publishDate] FROM [books]"
            UpdateCommand="UPDATE [books] SET [title] = @title, [publish] = @publish, [price] = @price, [publishDate] = @publishDate WHERE [isbn] = @original_isbn AND [title] = @original_title AND [publish] = @original_publish AND [price] = @original_price AND [publishDate] = @original_publishDate">
            <DeleteParameters>
                <asp:Parameter Name="original_isbn" Type="String" />
                <asp:Parameter Name="original_title" Type="String" />
                <asp:Parameter Name="original_publish" Type="String" />
                <asp:Parameter Name="original_price" Type="Int32" />
                <asp:Parameter Name="original_publishDate" Type="DateTime" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
                <asp:Parameter Name="original_isbn" Type="String" />
                <asp:Parameter Name="original_title" Type="String" />
                <asp:Parameter Name="original_publish" Type="String" />
                <asp:Parameter Name="original_price" Type="Int32" />
                <asp:Parameter Name="original_publishDate" Type="DateTime" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="isbn" Type="String" />
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
            </InsertParameters>
        </asp:SqlDataSource>
        <asp:ValidationSummary ID="validSummary" runat="server" ShowMessageBox="True"
            ValidationGroup="grid" ShowSummary="False" />
    
    </div>
    </form>
</body>
</html>
